/*jslint nomen: true, maxlen: 200, indent: 2*/
/*global rJS, console, window, document, RSVP, jIO*/

(function (window, rJS, jIO) {
  "use strict";
  
  function transform_olap_dimensions(g, dimensions) {
    var dimension;
    for (dimension in dimensions) {
      if (dimensions.hasOwnProperty(dimension)) {

      }
    }
  }
  
  function generate_schema() {
    
  }

  function render_form(gadget, scope, schema) {
    return gadget.getDeclaredGadget(scope)
      .push(function (g) {
        return g.render({
          schema: schema
        });
      });
  }

  rJS(window)
    .ready(function (g) {
      g.props = {};
      g.props.dimensions = {
        "Time": [
          {title: 'Year', const: '[Time].[Time].[Year]'},
          {title: 'Quarter', const: '[Time].[Time].[Quarter]'}
        ],
        "Product": [
          {title: 'Product Family', const: '[Product].[Products].[Product Family]'},
          {title: 'Product Department', const: '[Product].[Products].[Product Department]'},
          {title: 'Product Category', const: '[Product].[Products].[Product Category]'}
        ]
      };
      g.props.dimensions = [
        {title: 'Year', const: '[Time].[Time].[Year]'},
        {title: 'Quarter', const: '[Time].[Time].[Quarter]'},
        {title: 'Product Family', const: '[Product].[Products].[Product Family]'},
        {title: 'Product Department', const: '[Product].[Products].[Product Department]'},
        {title: 'Product Category', const: '[Product].[Products].[Product Category]'}
      ];

      return RSVP.all([
        render_form(g, "columns", {
          title: "columns:",
          type: "array",
          items: {
            oneOf: g.props.dimensions
          }
        }),
        render_form(g, "rows", {
          title: "rows:",
          type: "array",
          items: {
            oneOf: g.props.dimensions
          }
        })
      ]);
    })
    .allowPublicAcquisition("notifyValid", function (arr, scope) {
    })
    .allowPublicAcquisition("notifyInvalid", function (arr, scope) {
    })
    .allowPublicAcquisition("notifyChange", function (arr, scope) {
      var gadget = this;
      if (['rows', 'columns'].indexOf(scope) >= 0) {
        return this.getDeclaredGadget(scope)
          .push(function (g) {
            return g.getContent();
          })
          .push(function (ret) {
            var z = {};
            z[scope] = ret;
            return gadget.changeState(z);
          });
      }
    })
    .onStateChange(function () {
      var g = this;
      document.getElementById("json_document_content").textContent =
        JSON.stringify(g.state, null, 2);
    });

}(window, rJS, jIO));